import random
# ---------------------------------------------------------
# exercice 1
# ---------------------------------------------------------
# point 1
def fonction(n):
    return n*n-(n+1)*(n+1)-(n+2)*(n+n)+(n+3)*(n+3)

#point 2
def chocolat(qte):
    if qte<5:
        res=30*qte+20
    elif qte<10: #qte>=5
        res=29*qte+10
    else: #qte>=10
        res=28*qte
    return res
    
        
#point 3
def somme_accumulee(S,T,N):
    res=S
    for i in range(N):
        res+=res*T/100
    return res

# ---------------------------------------------------------
#exercice 2
# ---------------------------------------------------------
#point 1
def mystere_1():
    nombre_a_trouver=random.randint(1,100)
    gagne=False
    nb_essais=0
    while nb_essais<10 and not gagne:
        nb_essais+=1
        print("c'est votre essai n°",nb_essais)
        rep=int(input("Entrez votre choix "))
        if rep>nombre_a_trouver:
            print("Le nombre à trouver est plus petit")
        elif rep<nombre_a_trouver: #rep<= nombre_a_trouver
            print("Le nombre à trouver est plus grand")
        else: #rep==nombre_a_trouve
            print("Bravo vous avez gagné")
            gagne=True
    if not gagne:
        print("vous avez perdu! Il fallait trouver",nombre_a_trouver)

# point 2
def mystere_2():
    rep=input("Pensez à un nombre entre 1 et 100 et tapez sur ENTREE quand vous êtes prêt")
    trouve=False
    nb_essais=0
    debut=1
    fin=100
    while nb_essais<10 and not trouve:
        nb_essais+=1
        milieu=(debut+fin)//2
        print("Mon essai n°",nb_essais,":",milieu)
        rep=" "
        while rep not in '+-=':
            rep=input("Tapez + si c'est plus, - si c'est moins ou = si j'ai gagné ")
        if rep=="+":
            debut=milieu+1
        elif rep=="-":
            fin=milieu-1
        else:
            trouve=True
    if not trouve:
        print("Il semble que j'ai perdu mais êtes-vous sûr de ne pas avoir triché?")
    else:
        print("Youpi j'ai gagné en",nb_essais,"coups")

# ---------------------------------------------------------
#exercice 3
# ---------------------------------------------------------

# point 1

def trottinettes(annee):
    stock=1000
    for i in range((annee-2019)*12):
        stock=stock*.93+150
    return stock

# point 2
def max_trottinettes():
    stock=1000
    maxi=1000
    for i in range(240):
        stock=stock*.93+150
        if stock>maxi:
            maxi=stock
    return maxi

# point 3
def stable_trottinettes():
    stock=1000
    delta=1000
    mois=0
    while delta>0.000000000001:
        stock2=stock*.93+150
        delta=abs(stock2-stock)
        stock=stock2
        mois+=1
    return stock,2019+mois//12

# ---------------------------------------------------------
#Exercice 4
# ---------------------------------------------------------
# point 1
def liste_diviseurs(nb):
    res=[]
    for i in range(1,nb//2+1):
        if nb%i==0:
            res.append(i)
    return res

# point 2
def est_parfait(nb):
    liste_div=liste_diviseurs(nb)
    somme=0
    for i in range(len(liste_div)):
        somme+=liste_div[i]
    return somme==nb

# point 3
def liste_parfaits(nb):
    res=[]
    for i in range(nb+1):
        if est_parfait(i):
            res.append(i)
    return res

# ---------------------------------------------------------
#Exercice 5
# ---------------------------------------------------------
# point 1
def init_crible(N):
    res=[False,False]
    for i in range(2,N+1):
        res.append(True)
    return res

def barrer_multiples(crible,x):
    for i in range(2*x,len(crible),x):
        # i va prendre les valeurs 2*x, 3*x,4*x ...
        crible[i]=False

def crible_jusqu_a_n(N):
    res=[]
    crible=init_crible(N)
    for i in range(2,N+1):
        if crible[i]: # le case d'indice i est à True
            # i est un nombre premier
            res.append(i)
            # les multiples de i ne sont pas des nombres premiers
            barrer_multiples(crible,i)
    return res

def les_nombres_premiers():
    rep=int(input("Donnez jusqu'où vous rechercher les nombres premiers "))
    premiers=crible_jusqu_a_n(rep)
    print("Voici la liste:",premiers)

# ---------------------------------------------------------
# Exercice 5
# ---------------------------------------------------------

from turtle import *
def carre(cote,x,y):
    penup()
    goto(x,y)
    pendown()
    for i in range(4):
        forward(cote)
        right(90)

def ligne(cote,x,y,nbcol):
    for i in range(nbcol):
        carre(cote,x+i*cote,y)

def grille(cote,x,y,nblig,nbcol):
    for i in range(nblig):
        ligne(cote,x,y+i*cote,nbcol)

def test_grille():
    nb_lig=int(input("Combien de lignes ? "))
    nb_col=int(input("Combien de colonnes ? "))
    taille=int(input("Coté des carrés ? "))
    reset()
    grille(taille,0,0,nb_lig,nb_col)
    done()

    
def dessiner(debut,fin,pas):
    reset()
    i=debut
    penup()
    j=(i*i)/20
    goto(i,j)
    pendown()
    while i<fin:
        i+=pas
        j=(i*i)/20
        goto(i,j)
    done()

# ---------------------------------------------------------
# Pour tester les exos
# ---------------------------------------------------------

# print(fonction(12))
# print(chocolat(7))
# print(somme_accumulee(1000,2.3,10))
# mystere_1()
# mystere_2()
# print(trottinettes(2025))
# print(max_trottinettes())
# print(stable_trottinettes())
# print(liste_parfaits(10000))
# les_nombres_premiers()
# test_grille()
# dessiner(-70,70,1)
